diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
index 7f5c3215a..a8ca6f9b0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
@@ -3,13 +3,13 @@ package net.minecraft.client.render.tessellator;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.BufferUtils;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 import java.nio.ByteBuffer;
-import java.util.Arrays;
 
 public class TessellatorFont {
     private static final Logger LOGGER = LogUtils.getLogger();
@@ -42,7 +42,7 @@ public class TessellatorFont {
         GL41.glVertexAttribPointer(3, 4, GL41.GL_UNSIGNED_BYTE, true,   vertSize, offset); offset += 4;               // Color
         GL41.glVertexAttribPointer(4, 2, GL41.GL_UNSIGNED_BYTE, false,   vertSize, offset); offset += 2; // UV
         GL41.glVertexAttribPointer(5, 2, GL41.GL_UNSIGNED_BYTE, false,   vertSize, offset); offset += 2; // UV Sizes
-        GL41.glVertexAttrib2f(6, 15.5f/16f, 15.5f/16f);
+        GL41.glVertexAttrib1f(6, LightIndexHelper.lightIndex2i(15, 15));
 
         GL41.glEnableVertexAttribArray(0);
         GL41.glEnableVertexAttribArray(1);
@@ -100,7 +100,7 @@ public class TessellatorFont {
         GL41.glBindVertexArray(this.vao);
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
 
-        GL41.glVertexAttrib2f(6, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+        GL41.glVertexAttrib1f(6, GLRenderer.getLightIndex());
         GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STREAM_DRAW);
 
         GL41.glDrawArrays(DrawMode.POINTS.cap, 0, this.vertexCount);
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorGeneral.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorGeneral.java
index 2820b27fc..4b8806628 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorGeneral.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorGeneral.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.tessellator;
 
 public interface TessellatorGeneral extends TessellatorColor, TessellatorTextured, TessellatorLightmap, TessellatorNormal, Tessellator {
-
-
+    void setShade1i(int shade);
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLOD.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLOD.java
new file mode 100644
index 000000000..fc9788587
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLOD.java
@@ -0,0 +1,17 @@
+package net.minecraft.client.render.tessellator;
+
+public interface TessellatorLOD {
+    void startDrawingLOD();
+
+    boolean addLOD(
+        double x, double y, double z,
+        float r, float g, float b,
+        boolean minX, boolean maxX,
+        boolean minY, boolean maxY,
+        boolean minZ, boolean maxZ
+    );
+
+    void setTranslation(double x, double y, double z);
+
+    void offsetTranslation(double x, double y, double z);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLODShader.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLODShader.java
new file mode 100644
index 000000000..4d2375017
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLODShader.java
@@ -0,0 +1,159 @@
+package net.minecraft.client.render.tessellator;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.terrain.VertexConfig;
+import net.minecraft.client.render.terrain.VertexData;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3d;
+import org.lwjgl.BufferUtils;
+import org.lwjgl.opengl.GL41;
+import org.slf4j.Logger;
+
+import java.nio.ByteBuffer;
+import java.nio.ByteOrder;
+
+public class TessellatorLODShader implements TessellatorLOD {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    public @NotNull LODVertexData data;
+    public boolean drawing = false;
+
+    private final @NotNull Vector3d offset = new Vector3d();
+
+    public TessellatorLODShader(final int size) {
+        this.data = new LODVertexData(size);
+    }
+
+    private void checkIsDrawing() {
+        if(!this.drawing) {
+            throw new IllegalStateException("Not drawing!");
+        }
+    }
+
+    @Override
+    public void startDrawingLOD() {
+        if (this.drawing) {
+            throw new IllegalStateException("Already drawing!");
+        }
+
+        this.drawing = true;
+        this.data.vertexCount = 0;
+
+//        this.data.getBuffer().clear();
+    }
+
+    private static final int MASK_BOTTOM = 0b0000_0001;
+    private static final int MASK_TOP = 0b0000_0010;
+    private static final int MASK_NORTH = 0b0000_0100;
+    private static final int MASK_SOUTH = 0b0000_1000;
+    private static final int MASK_WEST = 0b0001_0000;
+    private static final int MASK_EAST = 0b0010_0000;
+
+    @Override
+    public boolean addLOD(
+        final double x, final double y, final double z,
+        final float r, final float g, final float b,
+        final boolean minX, final boolean maxX,
+        final boolean minY, final boolean maxY,
+        final boolean minZ, final boolean maxZ
+    ) {
+        this.checkIsDrawing();
+
+        if (!minX && !minY && !minZ && !maxX && !maxY && !maxZ) {
+            return false;
+        }
+
+//        this.data.resizeIfNeeded(64);
+//
+//        final @NotNull ByteBuffer buffer = this.data.getBuffer();
+//
+//        final int faces =
+//            (minY ? MASK_BOTTOM : 0) |
+//            (maxY ? MASK_TOP : 0) |
+//            (minZ ? MASK_NORTH : 0) |
+//            (maxZ ? MASK_SOUTH : 0) |
+//            (minX ? MASK_WEST : 0) |
+//            (maxX ? MASK_EAST : 0);
+//        final int color =
+//            ((((int) (r * 255.0f)) & 0xFF) << 0) |
+//            ((((int) (g * 255.0f)) & 0xFF) << 8) |
+//            ((((int) (b * 255.0f)) & 0xFF) << 16);
+//
+//        buffer.putFloat((float) (x + this.offset.x)).putFloat((float) (y + this.offset.y)).putFloat((float) (z + this.offset.z)); // Pos
+//        buffer.putFloat(r).putFloat(g).putFloat(b);
+//        buffer.putInt(faces); // Packed color + face culls
+//
+//        this.data.vertexCount++;
+
+        return true;
+    }
+
+    @Override
+    public void setTranslation(final double x, final double y, final double z) {
+        this.offset.x = x;
+        this.offset.y = y;
+        this.offset.z = z;
+    }
+
+    @Override
+    public void offsetTranslation(final double x, final double y, final double z) {
+        this.offset.x += x;
+        this.offset.y += y;
+        this.offset.z += z;
+    }
+
+    public static class LODVertexData extends VertexData<LODVertexConfig> {
+        public LODVertexData(final int size) {
+            super(new LODVertexConfig(), size);
+        }
+    }
+
+    public static class LODVertexConfig implements VertexConfig<LODVertexConfig> {
+        @Override
+        public @NotNull DrawMode drawMode() {
+            return DrawMode.POINTS;
+        }
+
+        @Override
+        public void enable(final int vao, final int vbo) {
+            GL41.glBindVertexArray(vao);
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
+
+            int offset = 0;
+            final int vertexSize = (Float.BYTES * 3) + (Float.BYTES * 3) + Integer.BYTES;
+            GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;      // Pos
+            GL41.glVertexAttribPointer(1, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;      // Pos
+            GL41.glVertexAttribPointer(2, 1, GL41.GL_UNSIGNED_INT, false, vertexSize, offset); offset += Integer.BYTES; // face culls
+
+            GL41.glEnableVertexAttribArray(0);
+            GL41.glEnableVertexAttribArray(1);
+            GL41.glEnableVertexAttribArray(2);
+        }
+
+        @Override
+        public void disable() {
+            GL41.glDisableVertexAttribArray(0);
+            GL41.glDisableVertexAttribArray(1);
+            GL41.glDisableVertexAttribArray(2);
+
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, 0);
+            GL41.glBindVertexArray(0);
+        }
+
+        @Override
+        public int getVertexSize() {
+            return (Float.BYTES * 3) + (Float.BYTES * 3) + Integer.BYTES;
+        }
+
+        @Override
+        public @NotNull LODVertexConfig copy() {
+            return this;
+        }
+
+        @Override
+        public boolean equals(final Object obj) {
+            return obj instanceof LODVertexConfig;
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLightmap.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLightmap.java
index 10f74ccaa..c90b61afa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLightmap.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorLightmap.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.render.tessellator;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.core.util.helper.LightIndexHelper;
 
 public interface TessellatorLightmap extends Tessellator{
-    void setLightmapCoord1i(int lightmapCoord);
+    void setLightmapCoord1i(int lightIndex);
     default void setLightmapCoord2i(int blockLight, int skyLight) {
-        setLightmapCoord1i(LightmapHelper.getLightmapCoord(skyLight, blockLight));
+        setLightmapCoord1i(LightIndexHelper.lightIndex2i(skyLight, blockLight));
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticle.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticle.java
index 47c24ffe1..a1175d945 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticle.java
@@ -6,7 +6,7 @@ import org.jetbrains.annotations.NotNull;
 public interface TessellatorParticle {
 
     void startDrawingParticles();
-    void setLightmapCoord1i(int lightmapCoord);
+    void setLightmapCoord1i(int lightIndex);
     void setColorOpaque3f(float r, float g, float b);
     void setColor4f(float r, float g, float b, float a);
     void setColorOpaque3i(int r, int g, int b);
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java
index e75ac25cb..1f5dd4dba 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.render.tessellator;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.BufferUtils;
@@ -24,7 +24,7 @@ public class TessellatorParticleShader implements TessellatorParticle {
     private final int vbo;
 
     private int color;
-    private int lightmapCoord;
+    private byte lightIndex;
 
     private double offsetX;
     private double offsetY;
@@ -39,13 +39,13 @@ public class TessellatorParticleShader implements TessellatorParticle {
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
 
         int offset = 0;
-        int vertexSize = 38;
+        int vertexSize = 37;
         GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;    // Pos
         GL41.glVertexAttribPointer(1, 1, GL41.GL_FLOAT, false, vertexSize, offset); offset += Float.BYTES;        // Scale
         GL41.glVertexAttribPointer(2, 4, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset);  offset += 4;          // Color
         GL41.glVertexAttribPointer(3, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UV
         GL41.glVertexAttribPointer(4, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UVSizes
-        GL41.glVertexAttribPointer(5, 2, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 2;           // Lightmap
+        GL41.glVertexAttribPointer(5, 1, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 1;           // Lightmap
 
         GL41.glEnableVertexAttribArray(0);
         GL41.glEnableVertexAttribArray(1);
@@ -64,15 +64,15 @@ public class TessellatorParticleShader implements TessellatorParticle {
         }
         this.drawing = true;
         this.color = 0xFFFFFFFF;
-        this.lightmapCoord = LightmapHelper.getLightmapCoord(15, 15);
+        this.lightIndex = LightIndexHelper.lightIndex2i(15, 15);
         this.count = 0;
         this.buffer.clear();
     }
 
-    public void setLightmapCoord1i(int lightmapCoord) {
+    public void setLightmapCoord1i(int lightIndex) {
         checkIsDrawing();
 
-        this.lightmapCoord = lightmapCoord;
+        this.lightIndex = (byte) lightIndex;
     }
 
     public void addParticle(double x, double y, double z, float scale, double u, double v, double uSize, double vSize) {
@@ -92,7 +92,7 @@ public class TessellatorParticleShader implements TessellatorParticle {
         this.buffer.putInt(this.color);
         this.buffer.putFloat((float) u).putFloat((float) v);
         this.buffer.putFloat((float) uSize).putFloat((float) vSize);
-        this.buffer.put((byte) ((LightmapHelper.getBlockLightFromCoord(this.lightmapCoord) << 4) + 7)).put((byte) ((LightmapHelper.getSkyLightFromCoord(this.lightmapCoord) << 4) + 7));
+        this.buffer.put(this.lightIndex);
 
 
         this.count++;
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorShader.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorShader.java
index a345f7fea..3b69f3879 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorShader.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorShader.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.tessellator;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
 import org.jetbrains.annotations.NotNull;
@@ -17,7 +16,8 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
     public byte config = 0;
 
     private int color;
-    private int lightmap;
+    private byte lightIndex;
+    private byte shade;
 
     private float texU;
     private float texV;
@@ -52,6 +52,7 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
         super.startDrawing(drawMode);
 
         this.lockColor = false;
+        this.shade = (byte) 0xFF;
         this.config = 0;
 
         this.quadEmulation = drawMode == DrawMode.QUADS && Tessellator.QUAD_EMULATION;
@@ -71,7 +72,15 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
         this.data.putFloat((float) (this.offsetZ + z));
 
         if((this.config & MASK_ENABLE_COLOR) != 0) {
-            this.data.putInt(this.color);
+            byte a = (byte) ((this.color & 0xFF000000) >> 24);
+            byte b = (byte) ((this.color & 0xFF0000) >> 16);
+            byte g = (byte) ((this.color & 0xFF00) >> 8);
+            byte r = (byte) ((this.color & 0xFF));
+            this.data
+                .put((byte) ((r * Byte.toUnsignedInt(this.shade)) >> 8))
+                .put((byte) ((g * Byte.toUnsignedInt(this.shade)) >> 8))
+                .put((byte) ((b * Byte.toUnsignedInt(this.shade)) >> 8))
+                .put(a);
         }
 
         if((this.config & MASK_ENABLE_TEXTURE) != 0) {
@@ -80,8 +89,7 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
         }
 
         if((this.config & MASK_ENABLE_LIGHTMAP) != 0) {
-            this.data.put((byte) ((LightmapHelper.getBlockLightFromCoord(this.lightmap) << 4) + 7));
-            this.data.put((byte) ((LightmapHelper.getSkyLightFromCoord(this.lightmap) << 4) + 7));
+            this.data.put(this.lightIndex);
         }
 
         if((this.config & MASK_ENABLE_NORMAL) != 0) {
@@ -151,7 +159,7 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
     }
 
     @Override
-    public void setLightmapCoord1i(int lightmapCoord) {
+    public void setLightmapCoord1i(int lightIndex) {
         checkIsDrawing();
         if ((this.config & MASK_ENABLE_LIGHTMAP) == 0) {
             if (this.vertexCount > 0) {
@@ -161,7 +169,7 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
             this.config |= MASK_ENABLE_LIGHTMAP;
         }
 
-        this.lightmap = lightmapCoord;
+        this.lightIndex = (byte) lightIndex;
     }
 
     @Override
@@ -224,7 +232,7 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
             size += 3;
         }
         if(lightmap) {
-            size += 2;
+            size += 1;
         }
 
         return size;
@@ -234,11 +242,11 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
         enableVertexAttribs(vao, vbo, (this.config & MASK_ENABLE_COLOR) != 0, (this.config & MASK_ENABLE_TEXTURE) != 0, (this.config & MASK_ENABLE_LIGHTMAP) != 0, (this.config & MASK_ENABLE_NORMAL) != 0);
     }
 
-    protected void enableVertexAttribs(int vao, int vbo, boolean color, boolean texture, boolean lightmap, boolean normal) {
+    protected void enableVertexAttribs(int vao, int vbo, boolean color, boolean texture, boolean lightIndex, boolean normal) {
         GL41.glBindVertexArray(vao);
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
 
-        int vertexSize = getVertexSize(color, texture, lightmap, normal);
+        int vertexSize = getVertexSize(color, texture, lightIndex, normal);
         int offset = 0;
         GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;    // Pos
         GL41.glEnableVertexAttribArray(0);
@@ -256,8 +264,8 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
             GL41.glDisableVertexAttribArray(2);
         }
 
-        if (lightmap) {
-            GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 2;    // Lightmap
+        if (lightIndex) {
+            GL41.glVertexAttribPointer(3, 1, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 1;    // Lightmap
             GL41.glEnableVertexAttribArray(3);
         } else {
             GL41.glDisableVertexAttribArray(3);
@@ -271,7 +279,7 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
         }
     }
 
-    protected void enableBufferedConfig(int vao, int vbo, boolean color, boolean texture, boolean lightmap, boolean normal) {
+    protected void enableBufferedConfig(int vao, int vbo, boolean color, boolean texture, boolean lightIndex, boolean normal) {
         GL41.glBindVertexArray(vao);
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
 
@@ -279,12 +287,18 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
             GL41.glVertexAttrib4f(1, 1f, 1f, 1f, 1f);
         }
 
-        if (!lightmap) {
-            GL41.glVertexAttrib2f(3, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+        if (!lightIndex) {
+            GL41.glVertexAttrib1f(3, GLRenderer.getLightIndex());
         }
 
         if (!normal) {
             GL41.glVertexAttrib3f(4, 0, -1, 0);
         }
     }
+
+    @Override
+    public void setShade1i(int shade) {
+        checkIsDrawing();
+        this.shade = (byte) shade;
+    }
 }
